
-- James Jonathan Cook

-- Reverse Polish Notation.



-- 5 1 2 + 4 * + 3 -

with trace
trace(1)

sequence input_tokens

input_tokens = {5,1,2,"+",4,"*","+",3,"-"}

function input_tokens_left()
	return length(input_tokens)
end function

function get_next_token()
	object ob
	ob = input_tokens[1]
	input_tokens = input_tokens[2..$]
	return ob
end function

sequence stack
stack = {}

procedure push_onto_stack(object ob)
	stack = append(stack, ob)
end procedure

function pop(integer n)
	object ob
	integer f
	f = length(stack) - n
	ob = stack[f+1..$]
	stack = stack[1..f]
	return ob
end function

sequence tokens
object token
object ans

while input_tokens_left() do
	token = get_next_token()
	if atom(token) then
		-- token is a value
		push_onto_stack(token)
	else
		-- token is an operator
		switch token do
		case "+", "add" then
			if length(stack) < 2 then
				abort(1/0)
			end if
			tokens = pop(2)
			ans = tokens[1] + tokens[2] -- do the addition
			push_onto_stack(ans)
		case "-", "subtract" then
			if length(stack) < 2 then
				abort(1/0)
			end if
			tokens = pop(2)
			ans = tokens[1] - tokens[2] -- do the addition
			push_onto_stack(ans)
		case "*", "multiply" then
			if length(stack) < 2 then
				abort(1/0)
			end if
			tokens = pop(2)
			ans = tokens[1] * tokens[2] -- do the addition
			push_onto_stack(ans)
		case "/", "divide" then
			if length(stack) < 2 then
				abort(1/0)
			end if
			tokens = pop(2)
			ans = tokens[1] / tokens[2] -- do the addition
			push_onto_stack(ans)
		case else
			-- do something
			printf(1, "Unsupported command \'%s\'\n", {token})
			abort(1/0)
		end switch
		tokens = {} -- deallocate to free memory
		
	end if
end while

? stack

getc(0)
--end of file.
